;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; grd_tetra - two rotated smooth shaded tetrahedrons
;; without OpenGL using
;; author - macgub
;; email  - macgub3@wp.pl
;; web -    macgub.hekko.pl
;; Thanks to lostcauz for intial version (I mean Windows
;; program template)
;;
;;
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
format PE GUI 4.0
entry start

include '/include/win32a.inc'

XRES equ 800 ;1600 ;1200 ;800      ;choose screen size
YRES equ 450 ; 900 ; 675 ;450
SIZE_X	equ XRES
SIZE_Y	equ YRES
ROUND equ 8
NON = 0
MMX = 1
SSE = 2
SSE2 = 3
Ext = SSE2


section '.text' code readable executable
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; start and message loop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start:
    invoke GetModuleHandle,0
    mov [wc.hInstance],eax
    invoke LoadIcon,0,IDI_APPLICATION
    mov [wc.hIcon],eax
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    mov [bmi.biSize],sizeof.BITMAPINFOHEADER
    mov [bmi.biWidth],XRES
    mov [bmi.biHeight],-YRES
    mov [bmi.biPlanes],1
    mov [bmi.biBitCount],32
    mov [bmi.biCompression],BI_RGB

    mov [bmi.biSizeImage],0
    mov [bmi.biXPelsPerMeter],0
    mov [bmi.biYPelsPerMeter],0
    mov [bmi.biClrUsed],0
    mov [bmi.biClrImportant],0

    mov [rect.left],0
    mov [rect.top],0
    mov [rect.right],XRES
    mov [rect.bottom],YRES
    invoke AdjustWindowRect,rect,WS_POPUP or WS_SYSMENU or WS_CAPTION,0 

    invoke RegisterClass,wc

    mov ecx,[rect.bottom]
    mov eax,[rect.right]
    sub ecx,[rect.top]
    sub eax,[rect.left] 

    invoke CreateWindowEx,0,_class,_title,WS_OVERLAPPEDWINDOW\
	   xor WS_THICKFRAME xor WS_MAXIMIZEBOX,0,0,eax,ecx,NULL,NULL,0,0
    mov [hwnd],eax
    invoke GetDC,[hwnd]
    mov [hdc],eax
    invoke ShowWindow,[hwnd],SW_SHOW

    invoke timeGetTime
    mov [s_time],eax	     ;initialize start time

msg_loop:
    invoke timeGetTime
    sub eax,[s_time]
    mov [e_time],eax	     ;get new end time

    stdcall g_draw
    inc  [ccounter]
    and  [ccounter],0x000000ff
    invoke StretchDIBits,[hdc],0,0,XRES,YRES,0,0,XRES,YRES,buffer,bmi,0,SRCCOPY
    invoke Sleep,1

    invoke PeekMessage,msg,0,0,0,PM_NOREMOVE
    or eax,eax
    je msg_loop

    invoke GetMessage,msg,NULL,0,0
    or eax,eax
    je end_loop
    invoke TranslateMessage,msg
    invoke DispatchMessage,msg

    jmp msg_loop

error:
    invoke MessageBox,NULL,_error,NULL,MB_ICONERROR+MB_OK

end_loop:
    invoke ReleaseDC,[hwnd],[hdc]
    invoke DestroyWindow,[hwnd]
    invoke ExitProcess,[msg.wParam]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; WindowProc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc WindowProc uses ebx esi edi, hwnd,wmsg,wparam,lparam
    cmp [wmsg],WM_KEYDOWN
    je .wmkeydown
    cmp [wmsg],WM_DESTROY
    je .wmdestroy
  .defwndproc:
    invoke DefWindowProc,[hwnd],[wmsg],[wparam],[lparam]
    jmp .finish
  .wmkeydown:
    cmp [wparam],VK_UP
    jne .vescape
;    stdcall g_init
    xor eax,eax
    jmp .finish
  .vescape:
    cmp [wparam],VK_ESCAPE
    jne .finish
  .wmdestroy:
    invoke PostQuitMessage,0
    xor eax,eax
  .finish: 
    ret
endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; g_draw - draw to screen buffer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc g_draw uses ebx esi edi
local temp dw ?
local zz1 dw ?, zz2 dw ?, zz3 dw ?
local xx1 dw ?, xx2 dw ?, xx3 dw ?
local yy1 dw ?, yy2 dw ?, yy3 dw ?
    pushad

    xor   eax,eax	   ; clear draw buffer
    mov   edi,buffer
    cld
    mov   ecx,XRES * YRES
    rep   stosd

    mov   eax,3000*65536    ; make background to Zbuffer
    mov   edi,Zbuffer
    mov   ecx,XRES * YRES
    rep   stosd

;    mov   esi,points_r
;    mov   edi,points_rotated
;  @@:
;    lodsd                  ; copy points
;    stosd
;    cmp   eax,-1
;    jnz   @b

  .rotate:
    fninit
    mov    esi,points_r
    mov    edi,points_rotated
    fild   [ccounter]
    fmul   [one_deg]
    fsincos
    fstp   [cos_beta]
    fstp   [sin_beta]
 @@:
    fld    dword[esi+4]
    fmul   [cos_beta]
    fld    dword[esi+8]
    fmul   [sin_beta]
    faddp
    fld    dword[esi+4]
    fmul   [sin_beta]
    fchs
    fld     dword[esi+8]
    fmul   [cos_beta]
    faddp
    fstp   dword[edi+8]
    fstp   dword[edi+4]
    push   dword[esi]
    pop    dword[edi]

    fld    dword[edi]
    fld    st
    fmul   [cos_beta]
    fld    dword[edi+8]
    fmul   [sin_beta]
    fchs
    faddp
    fstp   dword[edi]
    fmul   [sin_beta]
    fld    dword[edi+8]
    fmul   [cos_beta]
    faddp
    fstp   dword[edi+8]

    add    esi,12
    add    edi,12
    cmp    dword[esi],-1
    jnz    @b
    push   dword[esi]
    pop    dword[edi]


;    mov   eax,10*65536+20     ; draw flat triangle
;    add   eax,[ccounter]
;    mov   ebx,200*65536+36
;    add   ebx,[ccounter]
;    mov   ecx,100*65536+277
;    add   ecx,[ccounter]
;    mov   bedx,0xff00ffff
;    mov   edi,buffer
;    call  draw_triangle

    fninit

    mov   esi,triangles 	   ; draw triangles

  .draw_triangle:
    fninit
    movzx edx,word[esi]
    shl   edx,2
    lea   edx,[edx*3]
    add   edx,points_rotated
    fld   dword[edx]
    fmul  [scale]
    fistp [xx1]
    fld   dword[edx+4]
    fmul  [scale]
    fistp [yy1]
    fld   dword[edx+8]
    fmul  [scale]
    fistp [zz1]
					; z coord - skip
    movzx edx,word[esi+2]
    shl   edx,2
    lea   edx,[edx*3]
    add   edx,points_rotated
    fld   dword[edx]
    fmul  [scale]
    fistp [xx2]
    fld   dword[edx+4]
    fmul  [scale]
    fistp [yy2]
    fld   dword[edx+8]
    fmul  [scale]
    fistp [zz2]

    movzx edx,word[esi+4]
    shl   edx,2
    lea   edx,[edx*3]
    add   edx,points_rotated
    fld   dword[edx]
    fmul  [scale]
    fistp [xx3]
    fld   dword[edx+4]
    fmul  [scale]
    fistp [yy3]
    fld   dword[edx+8]
    fmul  [scale]
    fistp [zz3]

;    mov   eax,120*65536+20
;    mov   ebx,200*65536+15
;    mov   ecx,150*65536+200

    push  esi
    pushad
    push  [zz3]

    push  dword 0x00ff0001
    push  word 0x0001

    push  [zz2]
    push  dword 0x000100ff
    push  word 0x0001

    push  [zz1]
    push  dword 0x00010001
    push  word 0x00ff

    mov   esi,Zbuffer
    mov   edi,buffer

    movzx eax,[xx1]
    add   ax,[xxadd]
    shl   eax,16
    mov   ax,[yy1]
    add   ax,[yyadd]

    movzx ebx,[xx2]
    add   bx,[xxadd]
    shl   ebx,16
    mov   bx,[yy2]
    add   bx,[yyadd]

    movzx ecx,[xx3]
    add   cx,[xxadd]
    shl   ecx,16
    mov   cx,[yy3]
    add   cx,[yyadd]

    call  gouraud_triangle_z

    popad
    pushad

    push  [zz3]
    push  dword 0x00ff00ff
    push  word 0x00ff

    push  [zz2]
    push  dword 0x000000ff
    push  word 0x00ff
    push  [zz1]
    push  dword 0x00ff0000
    push  word 0x00ff

    mov   esi,Zbuffer
    mov   edi,buffer

    movzx eax,[xx1]
    add   ax,[xxadd1]
    shl   eax,16
    mov   ax,[yy1]
    add   ax,[yyadd]

    movzx ebx,[xx2]
    add   bx,[xxadd1]
    shl   ebx,16
    mov   bx,[yy2]
    add   bx,[yyadd]

    movzx ecx,[xx3]
    add   cx,[xxadd1]
    shl   ecx,16
    mov   cx,[yy3]
    add   cx,[yyadd]

    call  gouraud_triangle_z

    popad

    pop   esi
    add   esi,6
    cmp   dword[esi],-1
    jnz   .draw_triangle

    popad
ret
endp
;include 'flat3.inc'
include 'grd_cat.inc'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
section '.data' data readable writeable
    _class TCHAR 'grd_tetra',0
    _title TCHAR 'Gouraud shaded tetrahedrons',0
    _error TCHAR 'Startup failed.',0

    up		dd 0
    s_time	dd 0
    e_time	dd 0
    num_animations dd 3
    ccounter	   dd 0
    points_r:
      dd -1.0, -1.0, 1.0
      dd  1.0, -1.0, 1.0
      dd  0.0,	1.0, 0.0
      dd  0.0, -1.0, -1.0
      dd -1 ;<- end marker

    triangles:
       dw 0,2,1, 3,2,0, 1,2,3,	0,1,3
       dd -1 ;<- end marker

    scale    dd 200.0
    xxadd    dw XRES/4
    yyadd    dw YRES/2
    xxadd1   dw XRES*3/4
 ;   yyadd1   dw YRES*3/4
 ;   zzadd    dw 300
    one_deg  dd   0.024543692
    msg  MSG
    rect RECT

    wc WNDCLASS 0,WindowProc,0,0,NULL,NULL,NULL,COLOR_BTNFACE+1,NULL,_class
    cos_beta dd ?
    sin_beta dd ?
    hwnd     dd ?
    hdc      dd ?
    bmi      BITMAPINFOHEADER
    buffer  rd XRES*YRES
    Zbuffer rd XRES*YRES
    points_rotated rb 1000

section '.idata' import data readable writeable
    library kernel32,'KERNEL32',\user32,'USER32',\gdi32,'GDI32',\winmm,'WINMM'

    include '\include\api\kernel32.inc'
    include '\include\api\user32.inc'
    include '\include\api\gdi32.inc'

    import winmm,timeGetTime,'timeGetTime'
